from .html import _cp1252 as _cp1252
from .namespaces import _base as _base, cc as cc, dc as dc, georss as georss, itunes as itunes, mediarss as mediarss, psc as psc
from .sanitizer import _HTMLSanitizer as _HTMLSanitizer, _sanitize_html as _sanitize_html
from .urls import _urljoin as _urljoin, make_safe_absolute_uri as make_safe_absolute_uri, resolve_relative_uris as resolve_relative_uris
from .util import FeedParserDict as FeedParserDict
from typing import Any

_base64decode: Any
bytes_: Any
chr = unichr

class _FeedParserMixin(_base.Namespace, cc.Namespace, dc.Namespace, georss.Namespace, itunes.Namespace, mediarss.Namespace, psc.Namespace):
    namespaces: Any = ...
    _matchnamespaces: Any = ...
    can_be_relative_uri: Any = ...
    can_contain_relative_uris: Any = ...
    can_contain_dangerous_markup: Any = ...
    html_types: Any = ...
    feeddata: Any = ...
    entries: Any = ...
    version: str = ...
    namespaces_in_use: Any = ...
    infeed: int = ...
    inentry: int = ...
    incontent: int = ...
    intextinput: int = ...
    inimage: int = ...
    inauthor: int = ...
    incontributor: int = ...
    inpublisher: int = ...
    insource: int = ...
    sourcedata: Any = ...
    contentparams: Any = ...
    _summaryKey: Any = ...
    namespacemap: Any = ...
    elementstack: Any = ...
    basestack: Any = ...
    langstack: Any = ...
    svgOK: int = ...
    title_depth: int = ...
    depth: int = ...
    property_depth_map: Any = ...
    def __init__(self) -> None: ...
    def _normalize_attributes(self, kv: Any) -> None: ...
    baseuri: Any = ...
    lang: Any = ...
    def unknown_starttag(self, tag: Any, attrs: Any): ...
    def unknown_endtag(self, tag: Any) -> None: ...
    def handle_charref(self, ref: Any) -> None: ...
    def handle_entityref(self, ref: Any): ...
    def handle_data(self, text: Any, escape: int = ...) -> None: ...
    def handle_comment(self, text: Any) -> None: ...
    def handle_pi(self, text: Any) -> None: ...
    def handle_decl(self, text: Any) -> None: ...
    def parse_declaration(self, i: Any): ...
    @staticmethod
    def map_content_type(content_type: Any): ...
    def track_namespace(self, prefix: Any, uri: Any) -> None: ...
    def resolve_uri(self, uri: Any): ...
    @staticmethod
    def decode_entities(element: Any, data: Any): ...
    @staticmethod
    def strattrs(attrs: Any): ...
    def push(self, element: Any, expecting_text: Any) -> None: ...
    def pop(self, element: Any, strip_whitespace: int = ...): ...
    def push_content(self, tag: Any, attrs_d: Any, default_content_type: Any, expecting_text: Any) -> None: ...
    def pop_content(self, tag: Any): ...
    @staticmethod
    def looks_like_html(s: Any): ...
    def _map_to_standard_prefix(self, name: Any): ...
    def _get_attribute(self, attrs_d: Any, name: Any): ...
    def _is_base64(self, attrs_d: Any, contentparams: Any): ...
    @staticmethod
    def _enforce_href(attrs_d: Any): ...
    def _save(self, key: Any, value: Any, overwrite: bool = ...) -> None: ...
    def _get_context(self): ...
    def _save_author(self, key: Any, value: Any, prefix: str = ...) -> None: ...
    def _save_contributor(self, key: Any, value: Any) -> None: ...
    def _sync_author_detail(self, key: str = ...) -> None: ...
    def _add_tag(self, term: Any, scheme: Any, label: Any) -> None: ...
    def _start_tags(self, attrs_d: Any) -> None: ...
    def _end_tags(self) -> None: ...
